<!DOCTYPE html>>
<head><title>doc</title>
<style> 
    * {
        margin: 0;
        padding: 0;
    }

    body {
        text-align: center;
    }

    h1 {
        margin-bottom: 20px;
    }

    h2 {
        margin-bottom: 20px;
    }

    .add_user {
        margin-bottom: 50px;
    }

    .users_list .user_card {
        margin-bottom: 20px;
    }

    .delete_user {
        margin-bottom: 50px;
    }
</style></style>
</head>
<body>
    <h2>Список користувачів</h2>
<div class="users_list"></div>
<div class="add_user">
    <form action="" onsubmit="return false" id="add_form">
        <input type="number" id="user_code" placeholder="Код">
        <input type="text" id="user_name" placeholder="назва">
        <input type="text" id="user_date_of_start" placeholder="Дата початку">
        <input type="text" id="user_date_of_end" placeholder="дата кінця">
        <input type="text" id="user_starting_price" placeholder="початкова ціна">
        <input type="text" id="user_final_price" placeholder="кінцева ціна">
        <button id="add_btn" class="btn btn-primary">Добавити користувача</button>
    </form>
</div>
<div class="delete_user">
    <form action="" onsubmit="return false">
        <input type="text" id="delete" placeholder="назва">
        <button id="delete_btn" class="btn btn-danger">Видалити користувача</button>
    </form>
</div>
<div class="change_user">
    <form action="" onsubmit="return false">
        <input type="text" id="change_name" placeholder="назва">
        <input type="text" id="change_date_of_start" placeholder="Дата початку">
        <input type="text" id="change_date_of_end" placeholder="дата кінця">
        <input type="text" id="change_starting_price" placeholder="початкова ціна">
        <input type="text" id="change_final_price" placeholder="кінцева ціна">
        <button id="change_btn" class="btn btn-primary">Змінити користувача</button>
    </form>
</div>
<script>
class Auction{
    constructor(code, name, dateofstart,dateofend, startingprice,finalprice) {
    this.code = code;
    this.name = name;
    this.dateofstart = dateofstart;
    this.dateofend = dateofend;
    this.startingprice = startingprice;
    this.finalprice = finalprice;
    
    }
}
class Auction1{
constructor(){
    this.auctionitem=[];
}
toString() {
            let res = "";
            for (let user of this.auctionitem) {
                res += user.name + " ";
            }
            return res;
        }

checkUsers(user_name) {
            let index = this.auctionitem.findIndex(user => user.name === user_name);
            if (index === -1) {
                return true;
            } else {
                return false;
            }
        }
add(object){
    if(object instanceof Auction){
        this.auctionitem.push(object);
    }
}



delete(name) {
            let index = this.auctionitem.findIndex(user => user.name === name);
            if (index > -1) {
                this.auctionitem.splice(index, 1);
            }
        }
        changeUser(name) {
            let new_name = document.querySelector("#change_name").value;
            let new_date_of_start = document.querySelector("#change_date_of_start").value;
            let new_date_of_end = document.querySelector("#change_date_of_end").value;
            let new_starting_price = document.querySelector("#change_starting_price").value;
            let new_final_price = document.querySelector("#change_final_price").value;
            let index = this.auctionitem.findIndex(user => user.name === name);
            if (index > -1) {
                if (new_date_of_start !== "") {
                    this.auctionitem[index].dateofstart = new_date_of_start;
                }
                if (new_name !== "") {
                    this.auctionitem[index].name = new_name;
                }
                if (new_date_of_end !== "") {
                    this.auctionitem[index].dateofend = new_date_of_end;
                }
                if (new_starting_price !== "") {
                    this.auctionitem[index].startingprice = new_starting_price;
                }
                if (new_final_price !== "") {
                    this.auctionitem[index].finalprice = new_final_price;
                }
            } else {
                alert("Такого користувача не існує");
            }
        }
}
let New = new Auction1();

    document.querySelector("#add_btn").addEventListener('click', () => {
        let code = document.querySelector("#user_code").value;
        let name = document.querySelector("#user_name").value;
        let dateofstart = document.querySelector("#user_date_of_start").value;
        let dateofend = document.querySelector("#user_date_of_end").value;
        let startingprice = document.querySelector("#user_starting_price").value;
        let finalprice = document.querySelector("#user_final_price").value;
        if (New.checkUsers(name)) {
            let new_user = new Auction(code, name, dateofstart,dateofend, startingprice,finalprice);
            New.add(new_user);
            showUsers(New);
            alert("Користувача успішно додано");
        } else {
            alert("Такий користувач вже існує");
        }
    });
    const showUsers = function (list) {
        let card_holder = document.querySelector(".users_list");
        card_holder.innerHTML = "";
        for (let user of list.trafficPolice) {
            card_holder.innerHTML += `<div class='user_card'><h3 class='user_card_full_name'>${user.name}</h3><h3 class='user_card_full_name'>${user.startingprice}</h3></div>`;
        }
    };

    document.querySelector("#delete_btn").addEventListener('click', () => {
        let del_name = document.querySelector("#delete").value;
        New.delete(del_name);
        console.log(New.auctionitem);
        showUsers(New);
    });

    document.querySelector("#change_btn").addEventListener('click', () => {
        let change_name = document.querySelector("#change_name").value;
        New.changeUser(change_name);
        console.log(New.auctionitem);
        showUsers(New);
    });

</script>
</body>
